const app = getApp()
import { paystatusList } from '../../utils/dict';
import WxValidate from '../../utils/wxValidate';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '报名管理', leftArrow: true, useBar: false },
        searchInfo: {},
        list: [],
        dialog: { title: '详细信息', show: false, type: '1' },
        info: {},
        projectList: [],
        form: {},
        statusList: paystatusList
    },
    initValidate() {
        const rules = { grouping_id: { required: true }, project_id: { required: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { grouping_id: { required: '请选择赛事分组' }, project_id: { required: '请选择组内项目' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    // 跳转菜单
    back(e) {
        wx.navigateBack({ delta: 1 })
    },
    // 查看
    toView: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        const arr = await app.$get(`/newCourt/api/enroll/${item._id}`);
        if (arr.errcode == '0') {
            // 用户信息
            const user = await app.$get(`/newCourt/api/user/${arr.data.openid}`);
            if (user.errcode = '0') { arr.data.user_name = user.data.name };
            // 赛事信息
            const match = await app.$get(`/newCourt/api/match/${arr.data.match_id}`);
            if (match.errcode = '0') { arr.data.match_name = match.data.name };
            // 赛事组别
            let group = match.data.grouping.find((i) => i._id == arr.data.grouping_id);
            if (group) { arr.data.grouping_name = group.name; }
            // 赛事项目
            const project = await app.$get(`/newCourt/api/matchProject/${arr.data.project_id}`)
            if (project.errcode = '0') { arr.data.project_name = project.data.name };
            that.setData({ info: arr.data })
            that.setData({ dialog: { title: '详细信息', show: true, type: '1' } })
        }
    },
    // 修改
    toEdit: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        const arr = await app.$get(`/newCourt/api/enroll/${item._id}`);
        if (arr.errcode == '0') {
            // 用户信息
            const user = await app.$get(`/newCourt/api/user/${arr.data.openid}`);
            if (user.errcode = '0') { arr.data.user_name = user.data.name };
            // 赛事信息
            const match = await app.$get(`/newCourt/api/match/${arr.data.match_id}`);
            if (match.errcode = '0') { arr.data.match_name = match.data.name; arr.data.grouping = match.data.grouping; };
            // 赛事组别
            let group = match.data.grouping.find((i) => i._id == arr.data.grouping_id);
            if (group) { arr.data.grouping_name = group.name; }
            // 赛事项目
            const project = await app.$get(`/newCourt/api/matchProject/${arr.data.project_id}`)
            if (project.errcode = '0') { arr.data.project_name = project.data.name };
            that.setData({ form: arr.data })
            that.setData({ dialog: { title: '信息维护', show: true, type: '2' } })
        }
    },
    // 赛事分组
    groupingChange: async function (e) {
        const that = this;
        let data = that.data.form.grouping[e.detail.value];
        that.setData({ 'form.grouping_id': data._id });
        that.setData({ 'form.grouping_name': data.name });
        let project = [];
        for (const val of data.project) {
            const arr = await app.$get(`/newCourt/api/matchProject/${val}`);
            if (arr.errcode == '0') { project.push(arr.data) }
        }
        that.setData({ projectList: project });
    },
    // 选择组内项目
    projectChange: function (e) {
        const that = this;
        let data = that.data.projectList[e.detail.value];
        that.setData({ 'form.project_id': data._id });
        that.setData({ 'form.project_name': data.name });
    },
    // 选择支付状态
    paystatusChange: function (e) {
        const that = this;
        let data = that.data.statusList[e.detail.value];
        if (data) that.setData({ 'form.pay_status': data.value })
    },
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            const arr = await app.$post(`/newCourt/api/enroll/${params.id}`, params);
            if (arr.errcode == '0') {
                wx.showToast({ title: `维护信息成功`, icon: 'success', duration: 2000 });
                that.watchLogin();
                that.toClose();
            } else {
                wx.showToast({ title: `${arr.errMsg}`, icon: 'fail', duration: 2000 });
            }
        }
    },
    // 退款
    toRefund: async function (e) {
        const that = this;
        const { item } = e.currentTarget.dataset;
        wx.showModal({
            title: '提示',
            content: '您是否确定要进行退款，一旦操作不可恢复？',
            async success(res) {
                if (res.confirm) {
                    const arr = await app.$post('/newCourt/api/payOrder/toRefund', { id: item.pay_id })
                    if (arr.errcode == '0') {
                        wx.showToast({ title: `退款成功`, icon: 'success', duration: 2000 });
                        that.watchLogin();
                    } else {
                        wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 });
                    }
                } else if (res.cancel) { }
            }
        });
    },
    // 关闭弹框
    toClose: function () {
        const that = this;
        that.setData({ dialog: { title: '详细信息', show: false, type: '1' } })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        //验证规则函数
        that.initValidate();
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                const arr = await app.$get(`/newCourt/api/enroll`, { skip: 0, limit: 1000 });
                if (arr.errcode == '0') {
                    that.setData({ list: arr.data })
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})